#include "stdafx.h"
#include "InternetProtocol.h"

HRESULT __stdcall CInternetProtocol::Continue( PROTOCOLDATA *pProtocolData ){ return S_OK; }

HRESULT __stdcall CInternetProtocol::Abort( HRESULT hrReason,DWORD dwOptions ) { return S_OK; }

HRESULT __stdcall CInternetProtocol::Terminate( DWORD dwOptions ) { return S_OK; }

HRESULT __stdcall CInternetProtocol::Suspend( void ) { return S_OK; }

HRESULT __stdcall CInternetProtocol::Resume( void ) { return S_OK; }

HRESULT __stdcall CInternetProtocol::Seek( LARGE_INTEGER dlibMove, DWORD dwOrigin, ULARGE_INTEGER *plibNewPosition )
{
	// Let's pretend the seek operation is unsupported: it seems the IE never calls it, anyway.
	if( NULL != plibNewPosition )
		plibNewPosition->QuadPart = 0;
	return S_FALSE;
	/*
	__int64 newPos = m_ptr + dlibMove.QuadPart;

	switch( dwOrigin )
	{
		case FILE_BEGIN:
			newPos = dlibMove.QuadPart;
			break;
		case FILE_CURRENT:
			newPos = m_ptr + dlibMove.QuadPart;
			break;
		case FILE_END:
			newPos = dlibMove.QuadPart + m_buff.GetCount();
			break;
		default:
			return E_INVALIDARG;
	}

	if( newPos < 0 || newPos > m_buff.GetCount() )
			return E_INVALIDARG;
	plibNewPosition->QuadPart = newPos;
	m_ptr = (int)(newPos);
	return S_OK;
	*/
}

HRESULT __stdcall CInternetProtocol::LockRequest( DWORD dwOptions ) { return S_OK; }

HRESULT __stdcall CInternetProtocol::UnlockRequest( void ) { return S_OK; }

HRESULT __stdcall CInternetProtocol::Read( void *pv, ULONG cb, ULONG *pcbRead )
{
	const int nToRead = std::min<int>( cb, s_BuffSize );
	const int nRead = m_currStream->Read( m_buff, 0, nToRead );
	for( int i = 0; i < nRead; i++ )
		( (BYTE*)(pv))[ i ] = m_buff[ i ];
	*pcbRead = nRead;
	return ( nRead > 0 ) ? S_OK : S_FALSE;
}

HRESULT __stdcall CInternetProtocol::Start( LPCWSTR szUrl,
                                            IInternetProtocolSink *pOIProtSink, IInternetBindInfo *pOIBindInfo,
                                            DWORD grfPI, HANDLE_PTR dwReserved )
{
	m_buff = gcnew array<Byte>( s_BuffSize );

	CComQIPtr<::IServiceProvider> provider = pOIProtSink;
	int length = 0;
	if( NULL != provider )
	{
		CComPtr<::IHttpNegotiate> negotiate;
		HRESULT hr = provider->QueryService( IID_IHttpNegotiate, IID_IHttpNegotiate, (void**)&negotiate );
		if( FAILED( hr ) ) return hr;

		LPWSTR strAdditionalHeaders;
		hr = negotiate->BeginningTransaction( szUrl, L"", 0, &strAdditionalHeaders );
		if( FAILED( hr ) ) return hr;

		System::IO::Stream^ newStream = nullptr;
		length = m_handler->getStream( gcnew String( szUrl ), newStream );

		if( 0 == length || nullptr == newStream )
		{
			// Empty stream.
			// Create new System::IO::MemoryStream managed object, and write the message there.
			CStringA msg( "The document stream is empty." );
			length = msg.GetLength();
			gcroot<array<Byte>^> arrBytes = gcnew array<Byte>( length );
			for( int i=0; i < length; i++ )
				arrBytes[i] = msg[i];
			m_currStream = gcnew System::IO::MemoryStream( arrBytes );
		}
		else
		{
			m_currStream = newStream;
			m_currStream->Seek( 0, System::IO::SeekOrigin::Begin );
		}

		CString strResponseHeaders;
		strResponseHeaders.Format( L"HTTP/1.1 200 OK\r\n"
		                           L"Content-Type: text/html; charset=utf-8\r\n"
		                           L"Content-Length:%i\r\n\r\n",
		                           length );

		LPWSTR strNewResponseHeaders;
		hr = negotiate->OnResponse( 200, strResponseHeaders, strAdditionalHeaders, &strNewResponseHeaders);
		if( FAILED( hr ) ) return hr;
	}

	const ULONG ulResponseSize = length;
	// Report the amount of data that is available on the thread
	pOIProtSink->ReportData( BSCF_LASTDATANOTIFICATION, ulResponseSize, ulResponseSize );

	// Report the result of the operation
	pOIProtSink->ReportResult( 0, 200, L"" );
	return S_OK;
}
