#pragma once
#include "ProtocolPlugin.h"

// This COM object implements unmanaged IInternetProtocol COM interface declared in the <UrlMon.h> header.
class   __declspec( novtable )
		__declspec( uuid("{0A8C2296-89FD-4cca-8ADD-89411925CC4B}") ) 
	CInternetProtocol:
		public CComObjectRootEx< CComMultiThreadModel >,
		public CComCoClass< CInternetProtocol, &__uuidof(CInternetProtocol) >,
		public IInternetProtocol
{
public:
	CInternetProtocol(){}

	BEGIN_COM_MAP( CInternetProtocol )
		COM_INTERFACE_ENTRY( IInternetProtocol )
	END_COM_MAP()

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	// Internal buffer size, bytes
	static const int s_BuffSize = 1024;

	HRESULT FinalConstruct()
	{
		// __debugbreak();
		return S_OK;
	}

	void FinalRelease()
	{
	}

	// IInternetProtocol members.

	virtual HRESULT __stdcall Start( LPCWSTR szUrl, IInternetProtocolSink *pOIProtSink,
		IInternetBindInfo *pOIBindInfo, DWORD grfPI, HANDLE_PTR dwReserved );

	virtual HRESULT __stdcall Continue( PROTOCOLDATA *pProtocolData );

	virtual HRESULT __stdcall Abort( HRESULT hrReason,DWORD dwOptions );

	virtual HRESULT __stdcall Terminate( DWORD dwOptions );

	virtual HRESULT __stdcall Suspend( void );

	virtual HRESULT __stdcall Resume( void );

	virtual HRESULT __stdcall Read( void *pv,ULONG cb, ULONG *pcbRead );

	virtual HRESULT __stdcall Seek( LARGE_INTEGER dlibMove,DWORD dwOrigin,ULARGE_INTEGER *plibNewPosition );

	virtual HRESULT __stdcall LockRequest( DWORD dwOptions );

	virtual HRESULT __stdcall UnlockRequest( void );

	void SetHandler( ProtocolPlugin::iProtoPlug ^_handler ){ m_handler = _handler; }

private:
	// Managed current stream object.
	gcroot<System::IO::Stream^> m_currStream;

	// Reference of the managed request handling object.
	gcroot<ProtocolPlugin::iProtoPlug^> m_handler;

	// Managed internal buffer object.
	// When the IInternetProtocol::Read method is called,
	// the response data is first being read from managed System::IO::Stream to this managed array,
	// then the data is copied from this array to the caller of the IInternetProtocol::Read method ( i.e. to the unmanaged IE ActiveX control )
	// See CInternetProtocol::Read implementation for more details.
	gcroot<array<Byte>^> m_buff;
};
