#include "stdafx.h"
#include "ProtocolPlugin.h"
#include "InternetProtocol.h"

class CPlugProtoModule : public CAtlDllModuleT< CPlugProtoModule >{};

static CPlugProtoModule _AtlModule;

using namespace ProtocolPlugin;

// Unmanaged COM class factory for CInternetProtocol type.
class __declspec(novtable) CFactory:
	public CComObjectRootEx< CComMultiThreadModel >,
	public IClassFactory
{
	BEGIN_COM_MAP(CFactory)
		COM_INTERFACE_ENTRY(IClassFactory)
	END_COM_MAP()

	HRESULT FinalConstruct() { return S_OK; }

	void FinalRelease() { }

	virtual HRESULT STDMETHODCALLTYPE CreateInstance( IUnknown *pUnkOuter, REFIID riid, void **ppvObject)
	{
		// __debugbreak();
		if( riid == IID_IUnknown || riid == __uuidof( CInternetProtocol ) )
		{
			CComObject<CInternetProtocol>* pNewObject = new CComObject<CInternetProtocol>();
			pNewObject->AddRef();
			pNewObject->SetHandler( m_handler );
			IInternetProtocol *pi = pNewObject;
			*ppvObject = (void*)pi;
			return S_OK;
		}
		return E_NOINTERFACE;
	}

	virtual HRESULT STDMETHODCALLTYPE LockServer( BOOL fLock )
	{
		return S_OK;
	}

private:
	// Reference to the managed request handling object.
	gcroot<iProtoPlug^> m_handler;

public:
	// Initialize 
	void SetHandler( iProtoPlug ^_handler ){ m_handler = _handler; }
};

// The main managed class: constructor
ProtoPlug::ProtoPlug( System::String ^strProto, iProtoPlug ^handler )
{
	m_pClassFactory = NULL;
	// __debugbreak();

	CComPtr<IInternetSession> session;
	HRESULT hr = CoInternetGetSession( 0, &session, 0 );
	if(FAILED(hr))
		throw gcnew COMException( "::CoInternetGetSession failed", hr );

	CComObject<CFactory>* pNewObject = new CComObject<CFactory>();
	pNewObject->SetHandler( handler );

	m_pClassFactory = pNewObject;
	m_pClassFactory->AddRef();

	hr = session->RegisterNameSpace( m_pClassFactory, __uuidof( CInternetProtocol ), CString( strProto ), 0, NULL, 0 );

	if(FAILED(hr)) throw gcnew COMException( "IInternetSession::RegisterNameSpace failed", hr );
}

// The main managed class: destructor i.e. IDisposable.Dispose()
ProtoPlug::~ProtoPlug()
{
	if( NULL != m_pClassFactory )
	{
		m_pClassFactory->Release();
		m_pClassFactory = NULL;
	}
}
